ChangeLog for logilab.common
============================

2014-11-05  --  0.63.0
    * drop compatibility with python <= 2.5 (#264017)

    * fix textutils.py doctests for py3k

    * produce a clearer exception when dot is not installed (#253516)
 
    * make source python3-compatible (3.3+), without using 2to3.  This
     introduces a dependency on six (#265740)

    * fix umessage header decoding on python 3.3 and newer (#149345)

    * WARNING: the compat module no longer exports 'callable', 'izip', 'imap',
     'chain', 'sum', 'enumerate', 'frozenset', 'reversed', 'sorted', 'max',
     'relpath', 'InheritableSet', or any subprocess-related names.

2014-07-30  --  0.62.1
    * shellutils: restore py 2.5 compat by removing usage of class decorator

    * pytest: drop broken --coverage option

    * testlib: support for skipping whole test class and conditional skip, don't
     run setUp for skipped tests

    * configuration: load options in config file order (#185648)



2014-03-07  --  0.62.0
    * modutils: cleanup_sys_modules returns the list of cleaned modules



2014-02-11  --  0.61.0
    * pdf_ext: removed, it had no known users (CVE-2014-1838)

    * shellutils: fix tempfile issue in Execute, and deprecate it
     (CVE-2014-1839)

    * pytest: use 'env' to run the python interpreter

    * graph: ensure output is ordered on node and graph ids (#202314)



2013-16-12  --  0.60.1
    * modutils:

    * don't propagate IOError when package's __init__.py file doesn't
         exist (#174606)

    * ensure file is closed, may cause pb depending on the interpreter, eg
       pypy) (#180876)

    * fix support for `extend_path` based nested namespace packages ;
       Report and patch by John Johnson (#177651)

    * fix some cases of failing python3 install on windows platform / cross
     compilation (#180836)



2013-07-26  --  0.60.0
    * configuration: rename option_name method into option_attrname (#140667)

    * deprecation: new DeprecationManager class (closes #108205)

    * modutils:

        - fix typo causing name error in python3 / bad message in python2
       (#136037)
        - fix python3.3 crash in file_from_modpath due to implementation
        change of imp.find_module wrt builtin modules (#137244)

    * testlib: use assertCountEqual instead of assertSameElements/assertItemsEqual
      (deprecated), fixing crash with python 3.3 (#144526)

    * graph: use codecs.open avoid crash when writing utf-8 data under python3
      (#155138)



2013-04-16  --  0.59.1
    * graph: added pruning of the recursive search tree for detecting cycles in
      graphs (closes #2469)

    * testlib: check for generators in with_tempdir (closes #117533)

    * registry:

        - select_or_none should not silent ObjectNotFound exception
        (closes #119819)
        - remove 2 accidentally introduced tabs breaking python 3 compat
        (closes #117580)

    * fix umessages test w/ python 3 and LC_ALL=C (closes #119967, report and
      patch by Ian Delaney)



2013-01-21  --  0.59.0
    * registry:

        - introduce RegistrableObject base class, mandatory to make
          classes automatically registrable, and cleanup code
          accordingly
        - introduce objid and objname methods on Registry instead of
          classid function and inlined code plus other refactorings to allow
          arbitrary objects to be registered, provided they inherit from new
          RegistrableInstance class (closes #98742)
        - deprecate usage of leading underscore to skip object registration, using
          __abstract__ explicitly is better and notion of registered object 'name'
          is now somewhat fuzzy
        - use register_all when no registration callback defined (closes #111011)

    * logging_ext: on windows, use colorama to display colored logs, if available (closes #107436)

    * packaging: remove references to ftp at logilab

    * deprecations: really check them

    * packaging: steal spec file from fedora (closes #113099)

    * packaging force python2.6 on rhel5 (closes #113099)

    * packaging Update download and project urls (closes #113099)

    * configuration: enhance merge_options function (closes #113458)

    * decorators: fix @monkeypatch decorator contract for dark corner
      cases such as monkeypatching of a callable instance: no more
      turned into an unbound method, which was broken in python 3 and
      probably not used anywhere (actually closes #104047).



2012-11-14  --  0.58.3
    * date: fix ustrftime() impl. for python3 (closes #82161, patch by Arfrever
      Frehtes Taifersar Arahesis) and encoding detection for python2 (closes
      #109740)

    * other python3 code and test fixes (closes #104047)

    * registry: Store.setdefault shouldn't raise RegistryNotFound (closes #111010)

    * table: stop encoding to iso-8859-1, use unicode (closes #105847)

    * setup: properly install additional files during build instead of install (closes #104045)



2012-07-30  --  0.58.2
    * modutils: fixes (closes #100757 and #100935)



2012-07-17  --  0.58.1
    * modutils, testlib: be more python implementation independant (closes #99493 and #99627)



2012-04-12  --  0.58.0
    * new `registry` module containing a backport of CubicWeb selectable objects registry (closes #84654)

    * testlib: DocTestCase fix builtins pollution after doctest execution.

    * shellutil: add argument to ``ProgressBar.update`` to tune cursor progression (closes #88981)

    * deprecated: new DeprecationWrapper class (closes #88942)



2012-03-22  --  0.57.2
    * texutils: apply_units raise ValueError if string isn'nt valid (closes #88808)

    * daemon: don't call putenv directly

    * pytest: do not enable extra warning other than DeprecationWarning.

    * testlib: DocTestCase fix builtins pollution after doctest execution.

    * testlib: replace sys.exit with raise ImportError (closes: #84159)

    * fix license in README

    * add trove classifiers (tell about python 3 support for pypi)



2011-10-28  --  0.57.1
    * daemon: change $HOME after dropping privileges (closes #81297)

    * compat: method_type for py3k use instance of the class to have a
      real instance method (closes: #79268)



2011-10-12  --  0.57.0
    * only install unittest2 when python version < 2.7 (closes: #76068)

    * daemon: make pidfile world-readable (closes #75968)

    * daemon: remove unused(?) DaemonMixin class

    * update compat module for callable() and method_type()

    * decorators: fix monkeypatch py3k compat (closes #75290)

    * decorators: provide a @cachedproperty decorator



2011-09-08  --  0.56.2
    * daemon: call initgroups/setgid before setuid (closes #74173)

    * decorators: @monkeypatch should produce a method object (closes #73920)

    * modutils: allow overriding of _getobj by suppressing mangling



2011-08-05  --  0.56.1
    * clcommands: #72450 --rc-file option doesn't work



2011-06-09  --  0.56.0
    * clcommands: make registration possible by class decoration

    * date: new datetime/delta <-> seconds/days conversion function

    * decorators: refactored @cached to allow usages such as
      @cached(cacheattr='_cachename') while keeping bw compat



2011-04-01  --  0.55.2
    * new function for password generation in shellutils

    * pyro_ext: allow to create a server without registering with a pyrons



2011-03-28  --  0.55.1
    * fix date.ustrftime break if year <= 1900

    * fix graph.py incorrectly builds command lines using %s to call dot

    * new functions to get UTC datetime / time



2011-02-18  --  0.55.0
    * new urllib2ext module providing a GSSAPI authentication handler, based on python-kerberos

    * graph: test and fix ordered_nodes() [closes #60288]

    * changelog: refactor ChangeLog class to ease overriding

    * testlib: Fix tag handling for generator.



2011-01-12  --  0.54.0
    * dropped python 2.3 support

    * daemon: we can now specify umask to daemonize function, and it return
     different exit code according to the process

    * pyro_ext: new ns_reregister function to ensure a name is still properly
     registered in the pyro name server

    * hg: new incoming/outgoing functions backward compatible with regards to
     mercurial version (eg hg 1.6 and earlier)

    * testlib/pytest: more deprecation and removed code. Still on the way to
     unittest2



2010-11-15  --  0.53.0
    * first python3.x compatible release

    * __init__: tempattr context manager

    * shellutils: progress context manager



2010-10-11  --  0.52.1
    * configuration: fix pb with option names as unicode string w/
      python 2.5. Makes OptionError available through the module

    * textutils: text_to_dict skip comments (# lines)

    * compat: dropped some 2.2 compat

    * modutils: Consider arch-specific installation for STD_LIB_DIR definition



2010-09-28  --  0.52.0
    * testlib is now based on unittest2, to prepare its own extinction.
      Warning are printed so you can easily migrate step by step.

    * restored python 2.3 compat in some modules, so one get a change to run
      pylint at least

    * textutils: use NFKD decomposition in unormalize()

    * logging_ext: don't try to use ansi colorized formatter when not in debug
      mode



2010-09-10  --  0.51.1
    * logging_ext: init_log function splitted into smaller chunk to ease reuse
      in other contexts

    * clcommands: enhanced/cleaned api, nicer usage display

    * various pylint detected errors fixed



2010-08-26  --  0.51.0
    * testlib: don't raise string exception (closes #35331)

    * hg: new module regrouping some mercurial utility functions

    * clcommands: refactored to get more object oriented api.

    * optparser: module is now deprecated, use clcommands instead

    * textutils: new split_url_or_path and text_to_dict functions

    * logging_ext:
      - init_log now accept optionaly any arbitrary handler
      - threshold default to DEBUG if debug flag is true  and no threshold specified

    * date: new ustrftime implementation working around datetime limitaion on dates < 1900



2010-06-04  --  0.50.3
    * logging: added new optional kw argument to init_log rotating_parameters

    * date: fix nb_open_days() codomain, positive natural numbers are expected

    * configuration:
      - skip option with no type, avoid pb with generated option such as long-help
      - handle level on man page generation



2010-05-21  --  0.50.2
    * fix licensing information: LGPL v2.1 or greater

    * daemon: new daemonize function

    * modutils: fix some false negative of is_standard_module with
     'from module import something" where something isn't a submodule

    * optik_ext: fix help generation for normal optparse using script if
      optik_ext has been imported (#24450)

    * textutils support 256 colors when available

    * testlib] add option splitlines to assertTextEquals



2010-04-26  --  0.50.1
    * implements __repr__ on nullobject

    * configuration: avoid crash by skipping option without 'type'
          entry while input a config

    * pyro_ext: raise PyroError instead of exception



2010-04-20  --  0.50.0
    * graph:
     - generate methods now takes an optional mapfile argument to generate
       html image maps
     - new ordered_nodes function taking a dependency graph dict as arguments
       and returning an ordered list of nodes

    * configuration:
     - nicer serialization of bytes / time option
     - may now contains several option provider with the same name
     - consider 'level' in option dict, --help displaying only option with level
       0, and automatically adding --long-help options for higher levels

    * textutils: case insensitive apply_unit

    * sphinx_ext: new module usable as a sphinx pluggin and containing a new
     'autodocstring' directive

    * ureports: output &#160; instead of &nbsp; for strict xhtml compliance

    * decorators: @cached propery copy inner function docstring



2010-03-16  --  0.49.0
    * date: new 'totime' function

    * adbh, db, sqlgen modules moved to the new logilab-database package

    * pytest: when -x option is given, stop on the first error even if
      there are multiple test directories



2010-02-26  --  0.48.1
    * adbh: added dbport optional argument to [backup|restore]_commands

    * db: fix date processing for SQLServer 2005

    * testlib: improve XML assertion by using ElementTree parser and a new 'context' lines argument



2010-02-17  --  0.48.0
    * date: fixed mx date time compat for date_range (#20651)

    * testlib: generative test should not be interrupted by self.skip() (#20648)



2010-02-10  --  0.47.0
    * adbh: changed backup / restore api (BREAKS COMPAT):
      - backup_command is now backup_commands (eg return a list of commands)
      - each command returned in backup_commands/restore_commands may now
        be list that may be used as argument to subprocess.call, or a string
        which will the requires a subshell
      - new sql_rename_col method

    * deprecation: deprecated now takes an optional 'stacklevel' argument, default to 2

    * date: some functions to ease python's datetime module usage have been backported
      from cubicweb



2009-12-23  --  0.46.0
    * db / adbh: added SQL Server support using Pyodbc

    * db:
        - New optional extra_args argument to get_connection.
        - Support Windows Auth for SQLServer by giving
          extra_args='Trusted_Connection' to the sqlserver2005 driver



2009-11-23  --  0.45.2
    * configuration:
      - proper bytes and time option types support
      - make Method usable as 'callback' value
      - fix #8849 Using plugins, options and .pylintrc crashes PyLint

    * graph: fix has_path returned value to include the destination node, else we get
      an empty list which makes think there is no path (test added)



2009-08-26  --  0.45.0
    * added function for parsing XML processing instructions



2009-08-07  --  0.44.0
    * remove code deprecated for a while now

    * shellutils: replace confirm function by RawInput class /ASK singleton

    * deprecation: new deprecated decorator, replacing both obsolete and deprecated_function



2009-07-21  --  0.43.0
    * dbf: a DBF reader which reads Visual Fox Pro DBF format with Memo field (module from Yusdi Santoso)

    * shellutils:
     - #9764 add title to shellutils.ProgressBar
     - #9796 new confirm function

    * testlib:
     - simplify traceback manipulation (skip first frames corresponding to testlib functions)
     - -c now captures DeprecationWarnings

    * sphinxutils: simplified API

    * modutils: new cleanup_sys_modules function that removes modules under a list
      of directories from sys.modules



2009-07-17  --  0.42.0
    * pyro_ext: new module for pyro utilities

    * adbh: fix default set_null_allowed implementation, new case_sensitive
     resource descriptor



2009-06-03  --  0.41.0
    * modutils: new extrapath argument to modpath_from_file (see function's
     docstring for explanation)

    * adbh: new alter_column_support flag, sql_set_null_allowed and
     sql_change_col_type methods



2009-05-28  --  0.40.1
    * date: handle both mx.DateTime and datetime representations

    * db: use sqlite native module's Binary, not StringIO



2009-05-14  --  0.40.0
    * python < 2.3 are now officially unsupported

    * #9162: new module with some sphinx utilities

    * #9166: use a global variable to control mx datetime / py datetime usage

    * db: add time adapter for pysqlite2, fix mysql bool and string handling

    * configuration: don't print default for store_true / store_false option
      or option with None as default



2009-04-07  --  0.39.1
    * fix #6760 umessage.decode_QP() crashes on unknown encoding



2009-03-25  --  0.39.0
    * fix #7915 (shellutils unusable under windows)

    * testlib:

    * new profile option using cProfile

    * allows to skip a module by raising TestSkipped from module import

    * modutils: locate modules in zip/egg archive

    * db: USE_MX_DATETIME global to control usage of mx.DateTime / py datetime



2009-01-26  --  0.38.0
    * setuptools / easy_install support!

    * removed some old backward compat code

    * adbh: new intersect_all_support attribute

    * contexts: new pushd context manager

    * shellutils: enhance acquire_lock method w/ race condition

    * configuration: fix case sensitivity pb w/ config file sections

    * pytest: reimplemented colorization



2009-01-08  --  0.37.2
    * configuration: encoding handling for configuration file generation

    * adbh: fix Datetime type map for mysql

    * logging_ext: drop lldebug level which shouldn't be there



2008-12-11  --  0.37.1
    * contexts: make the module syntactically correct wrt python2.4



2008-12-09  --  0.37.0
    * contexts: new module for context managers, keeping py <2.4 syntax compat
      for distribution (only `tempdir` cm for now)

    * tasksqueue: new module containing a class to handle prioritized tasks queue

    * proc: new module for process information / resource control

    * optik_ext: new time/bytes option types, using textutils conversion function

    * logging_ext: new set_log_methods / init_log utility functions



2008-10-30  --  0.36.0
    * configuration:
      - option yn is now behaving like a flag (i.e --ex : if ex.default=True and --ex in sys.args then ex.value=False)
      - new attribute hide in option (i.e --ex : if --ex has 'hide':True then the option will not be displayed in man or --help)

    * pytest:
      - add colors in display
      - new option --restart that skips tests that succeeded on last run

    * cache: new herits from dict class

    * decorators: add @require_version @require_module that skip test if decorators are not satisfied



2008-10-09  --  0.35.3
    * graph: new has_path method



2008-10-01  --  0.35.2
    * configuration:
      - fix #6011: lgc.configuration ignore customized option values
      - fix #3278: man page generation broken   

    * dropped context.py module which broke the debian package when
      some python <2.5 is installed (#5979)



2008-09-10  --  0.35.0
    * fix #5945: wrong edge properties in graph.DotBackend

    * testlib: filter tests with tag decorator

    * shellutils: new simple unzip function



2008-08-07  --  0.34.0
    * changelog: properly adds new line at the end of each entry

    * testlib: add a with_tempdir decorator ensuring all temporary files and dirs are removed

    * graph: improve DotBackend configuration. graphiz rendered can now be selected
      and additional graph parameter used

    * db: support of Decimal Type



2008-06-25  --  0.33.0
    * decorators: new @locked decorator

    * cache: make it thread safe, changed behaviour so that when cache size is 0
      and __delitem__ is called, a KeyError is raised (more consistent)

    * testlib:
      - added assertIsNot, assertNone and assertNotNone assertion
      - added assertUnorderedIterableEquals
      - added assertDirEquals
      - various failure output improvement

    * umessage: umessage.date() may return unparsable string as is instead of None

    * compat: adds a max function taking 'key' as keyword argument as in 2.5

    * configuration: escape rest when printing for default value



2008-06-08  --  0.32.0
    * textutils: add the apply_unit function

    * testlib:
      - added a assertXMLEqualsTuple test assertion
      - added a assertIs assertion



2008-05-08  --  0.31.0
    * improved documentation and error messages

    * testlib: support a msg argument on more assertions, pysqlite2 as default

    * pytest: pytestconf.py for customization



2008-03-26  --  0.30.0
    * db: remember logged user on the connection

    * clcommands: commands may be hidden (e.g. not displayed in help), generic
      ListCommandsCommand useful to build bash completion helpers 

    * changelog: module to parse ChangeLog file as this one, backported from
      logilab.devtools



2008-03-12  --  0.29.1
    * date: new nb_open_days function counting worked days between two date

    * adbh: add -p option to mysql commands to ask for password



2008-03-05  --  0.29.0
    * adbh: mysql doesn't support ILIKE, implement list_indices for mysql

    * db: mysql adapter use mx DateTime when available, fix unicode handling



2008-02-18  --  0.28.2
    * testlib: restore python2.3 compatibility



2008-02-15  --  0.28.1
    * testlib: introduce InnerTest class to name generative tests, fix
      generative tests description storage

    * pytest: fix -s option

    * modutils: included Stefan Rank's patch to deal with 2.4 relative import

    * configuration: don't give option's keywords not recognized by optparse,
      fix merge_options function



2008-02-05  --  0.28.0
    * date: new `add_days_worked` function

    * shellutils: new `chown` function

    * testlib: new `strict` argument to assertIsInstance

    * __init__: new `attrdict` and `nullobject` classes



2008-01-25  --  0.27.0
    * deprecation: new class_moved utility function

    * interface: fix subinterface handling



2008-01-10  --  0.26.1
    * optparser: support --version at main command level

    * testlib: added man page for pytest

    * textutils: fix a bug in normalize{_,_rest_}paragraph which may cause
      infinite loop if an indent string containing some spaces is given



2008-01-07  --  0.26.0
    * db: binarywrap support

    * modutils: new LazyObject class



2007-12-20  --  0.25.2
    * adbh: new needs_from_clause variable on db helper



2007-12-11  --  0.25.1
    * pytest: new --profile option, setup module / teardown module hook,
              other fixes and enhancements

    * db: mysql support fixes

    * adbh: fix postgres list_indices implementation



2007-11-26  --  0.25.0
    * adbh:
      - list_tables implementation for sqlite
      - new list_indices, create_index, drop_index methods

    * restore python < 2.4 compat



2007-10-29  --  0.24.0
    * decorators: new classproperty decorator

    * adbh: new module containing advanced db helper which were in the "db"
      module, with additional registered procedures handling 



2007-10-23  --  0.23.1
    * modutils: fix load_module_from_* (even with use_sys=False, it should
      try to get outer packages from sys.modules)



2007-10-17  --  0.23.0
    * db:

        - mark support_users and support_groups methods as obsolete in
          favor of users_support and groups_support attributes
        - new ilike_support property on dbms helpers
        - extended db helper api
        - completed mysql support

    * textutils: new unormalize function to normalize diacritical chars by
      their ascii equivalent

    * modutils: new load_module_from_file shortcut function

    * clcommands: pop_args accept None as value for expected_size_after,
      meaning remaining args should not be checked

    * interface: new extend function to dynamically add an implemented interface
      to a new style class      



2007-06-25  --  0.22.2
    * new 'typechanged' action for configuration.read_old_config



2007-05-14  --  0.22.1
    * important bug fix in db.py

    * added history in pytest debugger sessions

    * fix pytest coverage bug

    * fix textutils test

    * fix a bug which provoked a crash if devtools was not installed



2007-05-14  --  0.22.0
    * pytest improvements

    * shellutils: use shutil.move instead of os.rename as default action
      of mv

    * db: new `list_users` and `sql_drop_unique_constraint` methods on
      advanced helpers

    * deprecation: new `obsolete` decorator



2007-02-12  --  0.21.3
    * fixed cached decorator to use __dict__ instead of attribute lookup,
      avoiding potential bugs with inheritance when using cached class 
      methods



2007-02-05  --  0.21.2
    * fix ReST normalization (#3471)



2006-12-19  --  0.21.1
    * tree: make Node iterable (iter on its children)

    * configuration: fix #3197 (OptionsManagerMixin __init__ isn't passing
      correctly its "version" argument) 

    * textutils: new 'rest' argument to normalize_text to better deal with
      ReST formated text

    * some packaging fixes



2006-11-14  --  0.21.0
    * db:

        - new optional keepownership argument to backup|restore_database methods
        - only register mxDatetime converters on psycopg2 adapter if
          mx.DateTime is available

    * moved some stuff which was in common __init__ file into specific
      module. At this occasion new "decorators" and "deprecation" modules
      has been added

    * deprecated fileutils.[files_by_ext,include_files_by_ext,exclude_files_by_ext]
      functions in favor of new function shellutils.find        

    * mark the following modules for deprecation, they will be removed in a
      near version:

    * astutils: moved to astng

    * bind (never been used)

    * html: deprecated

    * logger/logservice: use logging module

    * monclient/monserver (not used anymore)

    * patricia (never been used)

    * twisted_distutils (not used anymore)

    * removed the following functions/methods which have been deprecated for a
      while now:

    * modutils.load_module_from_parts

    * textutils.searchall

    * tree.Node.leafs

    * fileutils.get_by_ext, filetutils.get_mode, fileutils.ensure_mode

    * umessage: more robust charset handling



2006-11-03  --  0.20.2
    * fileutils: new remove_dead_links function

    * date: add missing strptime import



2006-11-01  --  0.20.1
    * umessage:
      - new message_from_string function
      - fixed get_payload encoding bug

    * db: default postgres module is now psycopg2, which has been customized
      to return mx.Datetime objects for date/time related types



2006-10-27  --  0.20.0
    * db:
      - fixed date handling
      - new methods on advanced helper to generate backup commands

    * configuration: basic deprecated config handling support

    * new implementation of pytest

    * backport a dot backend from yams into a new "graph" module



2006-10-03  --  0.19.3
    * fixed bug in textutils.normalise_[text|paragraph] with unsplitable
      word larger than the maximum line size

    * added pytest.bat for windows installation

    * changed configuration.generate_config to include None values into the
      generated file



2006-09-25  --  0.19.2
    * testlib:
      - fixed a bug in find_test making it returns some bad test names
      - new assertIsInstance method on TestCase

    * optik_ext: make it works if mx.DateTime is not installed, in which case
      the date type option won't be available

    * test fixes



2006-09-22  --  0.19.1
    * db:

        - fixed bug when querying boolean on sqlite using python's bool type
        - fixed time handling and added an adapter for DateTimeDeltaType
        - added "drop_on_commit" argument to create_temporary_table on db helper
        - added missing implementation of executemany on pysqlite2 wrapper to
          support pyargs correctly like execute

    * optik_ext: fixed "named" type option to support csv values and to return
      a dictionary



2006-09-05  --  0.19.0
    * new umessage module which provides a class similar to the standard
      email.Message class but returning unicode strings

    * new clcommands module to handle commands based command line tool
      (based on the configuration module)

    * new "date" option type in optik_ext

    * new AttrObject in testlib to create objects in test with arbitrary attributes

    * add pytest to run project's tests and get rid of all runtests.py

    * add pytest option to enable design-by-contract using aspects

    * some enhancements to the configuration module



2006-08-09  --  0.18.0
    * added -c / --capture option to testlib.unittest_main

    * fixed bugs in lgc.configuration

    * optparser: added a OptionParser that extends optparse's with commands



2006-07-13  --  0.17.0
    * python2.5 compatibility (testlib.py + compat.py)

    * testlib.assertListEquals return all errors at once

    * new "password" option type in optik_ext

    * configuration: refactored to support interactive input of a configuration



2006-06-08  --  0.16.1
    * testlib: improved test collections

    * compat: added cmp argument to sorted



2006-05-19  --  0.16.0
    * testlib:

        - added a set of command line options (PYDEBUG is deprecated,
          use the -i/--pdb option, and added -x/--exitfirst option)
        - added support for generative tests

    * db:
      - fix get_connection parameter order and host/port handling
      - added .sql_temporary_table method to advanced func helpers
      - started a psycopg2 adapter

    * configuration: enhanced to handle default value in help and man pages
      generation (require python >= 2.4)



2006-04-25  --  0.15.1
    * db: add missing port handling to get_connection function and
      dbapimodule.connect methods

    * testlib: various fixes and minor improvements



2006-03-28  --  0.15.0
    * added "cached" decorator and a simple text progression bar into __init__

    * added a simple text progress bar into __init__

    * configuration: fixed man page generation when using python 2.4

    * db: added pysqllite2 support, preconfigured to handle timestamp using
      mxDatetime and to correctly handle boolean types



2006-03-06  --  0.14.1
    * backported file support and add LOG_CRIT to builtin in logservice module



2006-02-28  --  0.14.0
    * renamed assertXML*Valid to assertXML*WellFormed and deprecated the old name

    * fixed modutils.load_module_from_*



2006-02-03  --  0.13.1
    * fix some tests, patch contributed by  Marien Zwart

    * added ability to log into a file with make_logger()



2006-01-06  --  0.13.0
    * testlib: ability to skip a test

    * configuration:

        - cleaner configuration file generation
        - refactoring so that we can have more control on file
          configuration loading using read_config_file and load_config_file
          instead of load_file_configuration

    * modutils: fix is_relative to return False when from_file is a file
      located somewhere in sys.path

    * ureport: new "escaped" attribute on Text nodes, controling html escaping

    * compat: make set iterable and support more other set operations...

    * removed the astng sub-package, since it's now self-distributed as
      logilab-astng



2005-09-06  --  0.12.0
    * shellutils: bug fix in mv()

    * compat:
          - use set when available
          - added sorted and reversed

    * table: new methods and some optimizations

    * tree: added some deprecation warnings



2005-07-25  --  0.11.0
    * db: refactoring, added sqlite support, new helpers to support DBMS
      specific features



2005-07-07  --  0.10.1
    * configuration: added basic man page generation feature

    * ureports: unicode handling, some minor fixes

    * testlib: enhance MockConnection

    * python2.2 related fixes in configuration and astng



2005-05-04  --  0.10.0
    * astng: improve unit tests coverage

    * astng.astng: fix Function.format_args, new method
      Function.default_value, bug fix in Node.resolve

    * astng.builder: handle classmethod and staticmethod as decorator,
      handle data descriptors when building from living objects

    * ureports:
      - new docbook formatter
      - handle ReST like urls in the text writer
      - new build_summary utility function



2005-04-14  --  0.9.3
    * optik_ext: add man page generation based on optik/optparse options
      definition

    * modutils: new arguments to get_source_file to handle files without
      extensions

    * astng: fix problem with the manager and python 2.2 (optik related)



2005-02-16  --  0.9.2
    * textutils:

        - added epydoc documentation
        - new sep argument to the get_csv function
        - fix pb with normalize_* functions on windows platforms

    * fileutils:

        - added epydoc documentation
        - fixed bug in get_by_ext (renamed files_by_ext) with the
          exclude_dirs argument

    * configuration:
      - fixed a bug in configuration file generation on windows platforms
      - better test coverage

    * fixed testlib.DocTest which wasn't working anymore with recent
      versions of pyunit

    * added "context_file" argument to file_from_modpath to avoid
      possible relative import problems

    * astng: use the new context_file argument from Node.resolve()



2005-02-04  --  0.9.1
    * astng:

        - remove buggy print
        - fixed builder to deal with builtin methods
        - fixed raw_building.build_function with python 2.4

    * modutils: code cleanup, some reimplementation based on "imp",
      better handling of windows specific extensions, epydoc documentation

    * fileutils: new exclude_dirs argument to the get_by_ext function

    * testlib: main() support -p option to run test in a profiled mode

    * generated documentation for modutils in the doc/ subdirectory



2005-01-20  --  0.9.0
    * astng:

        - refactoring of some huge methods
        - fix interface resolving when __implements__ is defined in a parent
          class in another module
        - add special code in the builder to fix problem with qt
        - new source_line method on Node
        - fix sys.path during parsing to avoid some failure when trying
          to get imported names by `from module import *`, and use an astng
          building instead of exec'ing the statement
        - fix possible AttributeError with Function.type
        - manager.astng_from_file fallback to astng_from_module if possible

    * textutils: fix bug in normalize_paragraph, unquote handle empty string
      correctly

    * modutils:

        - use a cache in has_module to speed up things when heavily used
        - fix file_from_modpath to handle pyxml and os.path

    * configuration: fix problem with serialization/deserialization of empty
      string



2005-01-04  --  0.8.0
    * modutils: a lot of fixes/rewrite on various functions to avoid
      unnecessary imports, sys.path pollution, and other bugs (notably
      making pylint reporting wrong modules name/path)

    * astng: new "inspector" module, initially taken from pyreverse code
      (http://www.logilab.org/projects/pyreverse), miscellaneous bug fixes

    * configuration: new 'usage' parameter on the Configuration
      initializer

    * logger: unicode support

    * fileutils: get_by_ext also ignore ".svn" directories, not only "CVS"



2004-11-03  --  0.7.1
    * astng:

        - don't raise a syntax error on files missing a trailing \n.
        - fix utils.is_abstract (was causing an unexpected exception if a
          string exception was raised).
        - fix utils.get_implemented.
        - fix file based manager's cache problem.

    * textutils: fixed normalize_text / normalize_paragraph functions



2004-10-11  --  0.7.0
    * astng: new methods on the manager, returning astng with nodes for
      packages (i.e. recursive structure instead of the flat one), with
      automatic lazy loading + introduction of a dict like interface to
      manipulate those nodes and Module, Class and Function nodes.

    * logservice: module imported from the ginco project

    * configuration: added new classes Configuration and
      OptionsManager2Configuration adapter, fix bug in loading options
      from file

    * optik_ext/configuration: some new option type "multiple_choice"

    * fileutils: new ensure_mode function

    * compat: support for sum and enumerate



2004-09-23  --  0.6.0
    * db: added DBAPIAdapter

    * textutils: fix in pretty_match causing malformated messages in pylint
      added ansi colorization management

    * modutils: new functions get_module_files, has_module and file_from_modpath

    * astng: some new utility functions taken from pylint, minor changes to the
      manager API, Node.resolve doesn't support anymore "living" resolution,
      some new methods on astng nodes

    * compat: new module for a transparent compatibility layer between
      different python version (actually 2.2 vs 2.3 for now)



2004-07-08  --  0.5.2
    * astng: fix another bug in klassnode.ancestors() method...

    * db: fix mysql access

    * cli: added a space after the prompt



2004-06-04  --  0.5.1
    * astng: fix undefined var bug in klassnode.ancestors() method

    * ureports: fix attributes on title layout

    * packaging:fix the setup.py script to allow bdist_winst (well, the
      generated installer has not been tested...) with the necessary
      logilab/__init__.py file



2004-05-10  --  0.5.0
    * ureports: new Universal Reports sub-package

    * xmlrpcutils: new xmlrpc utilities module

    * astng: resolve(name) now handle (at least try) builtins

    * astng: fixed Class.as_string (empty parent when no base classes)

    * astng.builder: knows a little about method descriptors, Function with
      unknown arguments have argnames==None.

    * fileutils: new is_binary(filename) function

    * textutils: fixed some Windows bug

    * tree: base not doesn't have the "title" attribute anymore

    * testlib: removed the spawn function (who used that ?!), added MockSMTP,
      MockConfigParser, MockConnexion and DocTestCase (test class for
      modules embedding doctest). All mocks objects are very basic and will be
      enhanced as the need comes.

    * testlib: added a TestCase class with some additional methods then
      the regular unittest.TestCase class

    * cli: allow specifying a command prefix by a class attributes,more
      robust, print available commands on help

    * db: new "binary" function to get the binary wrapper for a given driver,
      and new "system_database" function returning the system database name
      for different DBMS.

    * configuration: better group control



2004-02-20  --  0.4.5
    * db: it's now possible to fix the modules search order. By default call
      set_isolation_level if psycopg is used



2004-02-17  --  0.4.4
    * modutils: special case for os.path in get_module_part

    * astng: handle special case where we are on a package node importing a module
      using the same name as the package, which may end in an infinite loop
      on relative imports in Node.resolve

    * fileutils: new get_by_ext function



2004-02-11  --  0.4.3
    * astng: refactoring of Class.ancestor_for_* methods (now
      depends on python 2.2 generators)

    * astng: make it more robust

    * configuration: more explicit exception when a bad option is
      provided

    * configuration: define a short version of an option using the "short"
      keyword, taking a single letter as value

    * configuration: new method global_set_option on the manager

    * testlib : allow no "suite" nor "Run" function in test modules

    * shellutils: fix bug in *mv*



2003-12-23  --  0.4.2
    * added Project class and some new methods to the ASTNGManger

    * some new functions in astng.utils

    * fixed bugs in some as_string methods

    * fixed bug in textutils.get_csv

    * fileutils.lines now take a "comments" argument, allowing to ignore
      comment lines



2003-11-24  --  0.4.1
    * added missing as_string methods on astng nodes

    * bug fixes on Node.resolve

    * minor fixes in textutils and fileutils

    * better test coverage (need more !)



2003-11-13  --  0.4.0
    * new textutils and shellutils modules

    * full astng rewrite, now based on the compiler.ast package from the
      standard library

    * added next_sbling and previous_sibling methods to Node

    * fix get_cycles



2003-10-14  --  0.3.5
    * fixed null size cache bug

    * added 'sort_by_column*' methods for tables



2003-10-08  --  0.3.4
    * fix bug in asntg, occurring with python2.3 and modules including an
      encoding declaration

    * fix bug in astutils.get_rhs_consumed_names, occurring in lists
      comprehension

    * remove debug print statement from configuration.py which caused a
      generation of incorrect configuration files.



2003-10-01  --  0.3.3
    * fix bug in modutils.modpath_from_file

    * new module corbautils



2003-09-18  --  0.3.2
    * fix bug in modutils.load_module_from_parts

    * add missing __future__ imports



2003-09-18  --  0.3.1
    * change implementation of modutils.load_module_from_name (use find_module
      and load_module instead of __import__)

    * more bug fixes in astng

    * new functions in fileutils (lines, export) and __init__ (Execute)



2003-09-12  --  0.3
    * expect "def suite" or "def Run(runner=None)" on unittest module

    * fixes in modutils

    * major fixes in astng

    * new fileutils and astutils modules

    * enhancement of the configuration module

    * new option type "named" in optik_the ext module



2003-06-18  --  0.2.2
    * astng bug fixes



2003-06-04  --  0.2.1
    * bug fixes

    * fix packaging problem



2003-06-02  --  0.2.0
    * add the interface, modutils, optik_ext and configuration modules

    * add the astng sub-package

    * miscellaneous fixes



2003-04-17  --  0.1.2
    * add the stringio module

    * minor fixes



2003-02-28  --  0.1.1
    * fix bug in tree.py

    * new file distutils_twisted



2003-02-17  --  0.1.0
    * initial revision



